
package de.ivu.elect.presentation.kandidatur.action;

import javax.inject.Inject;
import javax.inject.Named;

import de.ivu.elect.business.kandidatur.boundary.ErsatzkandidaturConversationSelect;
import de.ivu.elect.business.kandidatur.entity.Ersatzkandidatur;
import de.ivu.elect.business.security.UseCasePermission;
import de.ivu.elect.presentation.kandidatur.ErsatzkandidaturEditView;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

@Named(ErsatzkandidaturEditAction.COMPONENT_NAME)
public class ErsatzkandidaturEditAction extends AbstractErsatzkandidaturAction {

  private static final long serialVersionUID = 1L;

  public static final String COMPONENT_NAME = "ersatzkandidaturEditAction";

  @Inject
  private transient ErsatzkandidaturConversationSelect ersatzkandidaturConversationSelect;

  public ErsatzkandidaturEditAction() {
    super();
  }

  @Override
  public UseCasePermission getRequiredPermission() {
    return UseCasePermission.ERSATZKANDIDATUR_EDIT;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return getKandidaturEditGebietSecurity();
  }

  @Override
  protected boolean isDisabledInternal(Ersatzkandidatur ersatzkandidatur) {
    return false;
  }

  @Override
  protected String doIt(Ersatzkandidatur ersatzkandidatur) {
    ersatzkandidaturConversationSelect.setEntity(ersatzkandidatur);

    return ErsatzkandidaturEditView.VIEW_ID;
  }

  @Override
  public String getLabelKey() {
    return "entity.edit.action.edit";
  }

  @Override
  public String getIcon() {
    return appIcons.getIconEdit();
  }
}
